<?php
namespace Bushelpowered\Api\Markets\Aggregator\Bids\V1;

use \Bushelpowered\Api\Common\Request\EmptyRequest;
use \Bushelpowered\Api\Markets\Aggregator\Bids\V1\Response\BidsListResponse;
use \Bushelpowered\Api\Common\NotAuthenticated;
use \Bushelpowered\Api\Common\NotAuthorized;
use \Bidl\Php\Core\Builtins\UnknownError;

class GetBidsListOperation 
{
    public function __construct(public \Bidl\Php\Core\BidlClient $client)
    {
    }
    
    /**
     * @deprecated use request instead.
     */
    public function call(EmptyRequest $request, $headers): BidsListResponse | NotAuthenticated | NotAuthorized | UnknownError
    {
         return $this->client->call('api/markets/aggregator/bids/v1/GetBidsListOperation', $request, $this->getWrapper(), $headers);
    }
    
    public function request(EmptyRequest $request, GetBidsListOperationMetadata $hasHeaders): BidsListResponse | NotAuthenticated | NotAuthorized | UnknownError
    {
         return $this->client->call('api/markets/aggregator/bids/v1/GetBidsListOperation', $request, $this->getWrapper(), $hasHeaders->getMetaData());
    }
    
    private function getWrapper() {
        return new class () implements \Bidl\Php\Core\BidlResponse {

            /** @var BidsListResponse | NotAuthenticated | NotAuthorized | UnknownError */
            public $response;
        
            public function __construct()
            {
                $this->mapper = new \JsonMapper();
            }
            
            public function fromJson($data) 
            {
                switch($data->type) {
                  case 'api.markets.aggregator.bids.v1#GetBidsListOperationSuccess':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Markets\Aggregator\Bids\V1\Response\BidsListResponse::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthenticated':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthenticated::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                  case 'api.common#NotAuthorized':
                    $empty = (new \ReflectionClass(\Bushelpowered\Api\Common\NotAuthorized::class))->newInstanceWithoutConstructor();
                    $this->response = $this->mapper->map($data, $empty);
                    break;
                   default: 
                     $this->response = new \Bidl\Php\Core\Builtins\UnknownError('The response was not a valid bidl response.');
                }
            }
        };
    }
}